#include "DfpProgressDelegate.h"

#include <QProgressBar>

DfpProgressDelegate::DfpProgressDelegate(QObject *parent)
    : QItemDelegate(parent)
{}

QWidget *DfpProgressDelegate::createEditor(QWidget *parent,
                                           const QStyleOptionViewItem &/*option*/,
                                           const QModelIndex &index) const
{
    auto *pb = new QProgressBar(parent);
    pb->setMinimumWidth(120);
    pb->setValue(0);
    return pb;
}

void DfpProgressDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    auto *pb = qobject_cast<QProgressBar*>(editor);
    if(!pb)
        return;
    auto vl = index.model()->data(index, Qt::EditRole).toList();
    pb->setFormat(vl.value(0).toString());
    pb->setValue(vl.value(1, 0).toInt());
    auto color = index.model()->data(index, Qt::BackgroundRole).value<QColor>();

    auto p = pb->palette();
    p.setColor(QPalette::Text, color);
    p.setColor(QPalette::HighlightedText, color);
    pb->setPalette(p);
}

void DfpProgressDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    editor->setGeometry(option.rect);
}
