#include "DfpSignalRouter.h"

#include "DfpFlashModel.h"
#include "DfpTableView.h"
#include "EthFlashDevGlobal.h"
#include "EthFlashDev.h"

#include "lib-common/BaseConfigDispatcher.h"

void DfpSignalRouter::setDfpStatusModel(DfpTableView *p)
{
    dfpTableView = p;
    dfpModel = dfpTableView->getDfpModel();
}

void DfpSignalRouter::connect_FlashDevice(const EthFlashDevGlobal *devGlob) const
{
    auto dev = devGlob->getDevice<EthFlashDev>();
    ReadoutAppSignalRouter::connect_device(devGlob, dev);

    connect(dev, &EthFlashDev::fsmStateChanged,
            dfpModel, &DfpFlashModel::setDevState);
}

void DfpSignalRouter::connect_ConfigurationDispatcher() const
{
    ReadoutAppSignalRouter::connect_ConfigurationDispatcher();
    if(!configDispatcher)
        return;

    if(dfpModel) {
        configDispatcher->subscribeConfig(dfpModel);
    }
}
