#ifndef DFPSIGNALROUTER_H
#define DFPSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"

class ReadoutAppConfigDb;
class ReadoutAppConfigDispatcher;

class EthFlashDevGlobal;
class DfpTableView;
class DfpFlashModel;

class DfpSignalRouter : public ReadoutAppSignalRouter
{
    DfpSignalRouter() = default;
    Q_DISABLE_COPY_MOVE(DfpSignalRouter)
public:
    // Singleton
    static DfpSignalRouter & instance()
    {
        // thread-safe since C++11
        static DfpSignalRouter obj;
        return obj;
    }

    void setDfpStatusModel(DfpTableView *p);

    void setReadoutAppConfigDispatcher(ReadoutAppConfigDispatcher * p);

    void connect_FlashDevice(const EthFlashDevGlobal *devGlob) const;

private:
    void connect_ConfigurationDispatcher() const override;

    DfpTableView *dfpTableView = nullptr;
    DfpFlashModel *dfpModel = nullptr;

    ReadoutAppConfigDb * configDb = nullptr;
    ReadoutAppConfigDispatcher * readoutConfDisp = nullptr;
};
#endif // DFPSIGNALROUTER_H
