#include "EvIncompleteHelper.h"

#include <QStringList>

void EvIncompleteHelper::add(quint64 ev)
{
    ++tot;
    if(ranges.isEmpty()) {
        ranges.push_back({ev,ev}); // fill 1st range
        return;
    }

    auto &last = ranges.last();
    if(last.second+1 == ev) {
        last.second = ev; // modify last range
        return;
    }

    if(ranges.size() < 10) {
        ranges.push_back({ev,ev}); // fill next range
    } else {
        // skip extra ranges
    }
}

void EvIncompleteHelper::reset()
{
    tot = 0;
    ranges.clear();
}

QString EvIncompleteHelper::toString() const
{
    QStringList ret;
    ret << QString("tot: %L1").arg(tot);

    if(tot) {
        ret << "ranges:";
        for(auto r : ranges) {
            if(r.first == r.second)
                ret << QString("%L1").arg(r.first);
            else
                ret << QString("%L1-%L2").arg(r.first).arg(r.second);
        }
    }
    return ret.join(' ');
}
