#ifndef EVBCOMBINERCONFIG_H
#define EVBCOMBINERCONFIG_H

#include <QMetaType>

enum COMBINER_OUT{COMBINER_FILE=0, COMBINER_TCP=1, COMBINER_IDLE=2};
Q_DECLARE_METATYPE(COMBINER_OUT)
QDebug operator<<(QDebug dbg, const COMBINER_OUT &c);

struct EvbCombinerConfig
{
    friend bool operator==(const EvbCombinerConfig &, const EvbCombinerConfig &) = default;

    void checkAndRepair();

    COMBINER_OUT combinerOut = COMBINER_FILE;
    int combinerOutTcpNum = 0;
    quint64 outputBufSize = 0;
    bool infOutputEn = false;
    bool timeDistrEn = false;
    bool fixTlvFormat = true;
    quint16 monitorPort = 0;
    quint16 tcpOutPortBase = 0;
};
Q_DECLARE_METATYPE(EvbCombinerConfig)

QDebug operator<<(QDebug dbg, const EvbCombinerConfig &c);
QDataStream &operator<<(QDataStream &out, const EvbCombinerConfig &r);
QDataStream &operator>>(QDataStream &in, EvbCombinerConfig &r);

#endif // EVBCOMBINERCONFIG_H
