#include "MscHistTypeDelegate.h"

#include <QComboBox>

QWidget *MscHistTypeDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &model_index) const
{
    auto cb = new QComboBox(parent);

    cb->addItem("Interval", false);
    cb->addItem("Width", true);

    bool value = model_index.model()->data(model_index, Qt::EditRole).toBool();
    cb->setCurrentIndex(value ? 0 : 1);
    connect(cb, QOverload<int>::of(&QComboBox::currentIndexChanged),
            this, &MscHistTypeDelegate::dataChanged);
    return cb;
}

void MscHistTypeDelegate::setEditorData(QWidget *editor, const QModelIndex &model_index) const
{
    int value = model_index.model()->data(model_index, Qt::EditRole).toBool();
    QComboBox *cd = static_cast<QComboBox*>(editor);
    cd->blockSignals(true);
    cd->setCurrentIndex(value ? 1 : 0);
    cd->blockSignals(false);
}

void MscHistTypeDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &model_index) const
{
    QComboBox *cb = static_cast<QComboBox*>(editor);
    bool value = cb->currentData().toBool();
    if(model->data(model_index, Qt::EditRole).toBool() != value)
        model->setData(model_index, value, Qt::EditRole);
}
