/*
**    Copyright 2014-2016 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MSCINPUTCONFIG_H
#define MSCINPUTCONFIG_H

#include <QMetaType>
#include <QMap>

class QDataStream;

struct MscInputChConfig
{
    MscInputChConfig() = default;
    MscInputChConfig(quint16 ch) : histCh(ch) {}
    friend bool operator==(const MscInputChConfig &, const MscInputChConfig &) = default;

    bool isActiveHigh = false;
    quint16 histCh = 0;
    quint16 ceLut = 0xFFFF;
    quint16 histLut = 0xFFFF;
};
Q_DECLARE_METATYPE(MscInputChConfig)

typedef QMap<int, MscInputChConfig> MscInputConfig;
Q_DECLARE_METATYPE(MscInputConfig)

#endif // MSCINPUTCONFIG_H
